;  Teeny little x86 PC bootsector program 
;  Designed for the Netwide assembler, "nasm".
;  Compile into a boot block with "nasm -f bin boot.s -o boot.bin"
;   See http://nasm.sourceforge.net/doc/html/nasmdoc0.html
;  Orion Sky Lawlor, olawlor@acm.org, 2006/01/19 (Public Domain)

BITS 16         ; Starts running in 16-bit segmented DOS mode
SECTION .text   ; Put everything into the code ("text") segment
GLOBAL _start   ; Tells linker where code starts

_start: ; BIOS loads this code, and starts running right here
	mov bx, 0x0007  ; 'output character' selector
	mov ax, 0x0e41  ; low bits == ASCII 'A'
	int 0x10  ; "output character" interrupt

	mov ax, 0x0e2D  ; ASCII '-'
	int 0x10  

	mov ax, 0x0e4F  ; 'O'
	int 0x10

	mov ax, 0x0e4B  ; 'K'
	int 0x10 

	xor ax,ax  ; set ax to zero
	int 0x16  ; Wait for a keypress
	
	mov bx, 0x0007  ; 'output character' selector again
	mov ax, 0x0e52  ; 'R'
	int 0x10  ; "output character" interrupt
	
	jmp  0xf000:0xfff0 ; Jump to BIOS reset code

; A boot sector's last two bytes must contain this magic flag.
; This tells the BIOS it's OK to boot here; without this, 
;  you'll get the BIOS "Operating system not found" error.
	times 510-($-_start) db 0  ; pad to offset 510 
	dw 0xAA55 ; Magic value needed by BIOS
END
